summaryrefslogtreecommitdiff
path: root/archiso
diff options
context:
space:
mode:
authorGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-06-18 18:38:58 -0300
committerGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-06-18 18:38:27 -0300
commit85d243ff5836fc17416c65dca8a9e8b4e9d915bc (patch)
tree78b3ec86fea064580c43966da866d46e31ab7007 /archiso
parent4a1bd4c7697bdc7aa89eca04009d868e4dd39cb4 (diff)
[archiso] Use dm-snapshot instead of aufs2 (A.K.A. "The Big Commit")
* Use device mapper + snapshot module, instead union layer filesystem. * A block-level approach vs vfs-level. * No more unofficial (Linux) things. * More memory is needed. * Refactor mkarchiso. * Refactor hooks/archiso. * Fix install/archiso_pxe_nbd (due recent change in mkinitcpio-0.6.15 on checked_modules()/all_modules()) [Thanks Dave for the improved workaround] * New configs/releng to build official images. * Works with a Bash script instead of Makefile. (better control and easy to maintain) * Remove configs/syslinux-iso. * Remove archiso2dual script. Integrate functionality in configs/releng. * New configs/baseline to build the most basic live medium or use as template. * New README (draft). [Thanks Dieter for fixing english grammar] Signed-off-by: Gerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>
Diffstat (limited to 'archiso')
-rw-r--r--archiso/Makefile16
-rw-r--r--archiso/hooks/archiso207
-rw-r--r--archiso/install/archiso23
-rw-r--r--archiso/install/archiso_pxe_nbd8
-rwxr-xr-xarchiso/mkarchiso559
5 files changed, 510 insertions, 303 deletions
diff --git a/archiso/Makefile b/archiso/Makefile
index 93d68af..74f9ff2 100644
--- a/archiso/Makefile
+++ b/archiso/Makefile
@@ -1,6 +1,8 @@
all:
-install: all
+install: install-program install-examples install-doc
+
+install-program:
# install to sbin since script only usable by root
install -D -m 755 mkarchiso $(DESTDIR)/usr/sbin/mkarchiso
# testiso can be used by anyone
@@ -12,11 +14,16 @@ install: all
install -D -m 644 install/archiso_pxe_nbd $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
install -D -m 644 hooks/archiso_loop_mnt $(DESTDIR)/lib/initcpio/hooks/archiso_loop_mnt
install -D -m 644 install/archiso_loop_mnt $(DESTDIR)/lib/initcpio/install/archiso_loop_mnt
- # install docs and examples
+
+install-examples:
+ # install examples
install -d -m 755 $(DESTDIR)/usr/share/archiso/
cp -r ../configs $(DESTDIR)/usr/share/archiso/configs
- install -D -m 644 ../README $(DESTDIR)/usr/share/doc/archiso/README
+install-doc:
+ install -d -m 755 $(DESTDIR)/usr/share/archiso/
+ install -D -m 644 ../README $(DESTDIR)/usr/share/doc/archiso/README
+
uninstall:
rm -f $(DESTDIR)/usr/sbin/mkarchiso
rm -f $(DESTDIR)/usr/bin/testiso
@@ -25,4 +32,5 @@ uninstall:
rm -f $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_nbd
rm -f $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
rm -rf $(DESTDIR)/usr/share/archiso/
- rm -rf $(DESTDIR)/usr/share/doc/archiso/
+
+.PHONY: install install-program install-examples install-doc uninstall
diff --git a/archiso/hooks/archiso b/archiso/hooks/archiso
index a129b20..b81bbf7 100644
--- a/archiso/hooks/archiso
+++ b/archiso/hooks/archiso
@@ -1,158 +1,165 @@
-# args: source, mountpoint
-_mnt_aufs() {
- src="${1}"
- mnt="${2}"
- msg "::: Adding new aufs branch: ${src} to ${mnt}"
- mkdir -p "${mnt}"
- /bin/mount -t aufs -o remount,append:"${src}"=ro none "${mnt}"
+# Initialize loopback device logic (we using on-demand mode)
+# args: none
+_init_loop_dev() {
+ loop_dev_cnt=99
+}
+
+# Call this function before _make_loop_dev() each time.
+# args: none
+_next_loop_dev() {
+ loop_dev_cnt=$((loop_dev_cnt+1))
+}
+
+# Setup a loopback device for image passed as arguemnt and echo the path to loopback device used.
+# args: /path/to/image_file
+_make_loop_dev() {
+ local img="${1}"
+ mknod /dev/loop${loop_dev_cnt} b 7 ${loop_dev_cnt} &> /dev/null
+ losetup /dev/loop${loop_dev_cnt} "${img}" &> /dev/null
+ echo /dev/loop${loop_dev_cnt}
}
# args: source, mountpoint
-_mnt_bind() {
- src="${1}"
- mnt="${2}"
- msg "::: Binding ${src} to ${mnt}"
+_mnt_fs() {
+ local img="${1}"
+ local mnt="${2}"
+ local img_fullname="${img##*/}";
+ local img_name="${img_fullname%%.*}"
+ local ro_dev ro_dev_size ro_dev_fs_type rw_dev
+
mkdir -p "${mnt}"
- /bin/mount -o bind "${src}" "${mnt}"
+
+ _next_loop_dev
+ ro_dev=$(_make_loop_dev "${img}")
+ ro_dev_size=$(blockdev --getsz ${ro_dev})
+ ro_dev_fs_type=$(blkid -o value -s TYPE -p ${ro_dev} 2> /dev/null)
+
+ dd of="/cowspace/${img_name}.cow" count=0 seek=${ro_dev_size} &> /dev/null
+ _next_loop_dev
+ rw_dev=$(_make_loop_dev "/cowspace/${img_name}.cow")
+
+ echo "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} N 8" | dmsetup create ${img_name}
+
+ msg ":: Mounting '/dev/mapper/${img_name}' (${ro_dev_fs_type}) to '${mnt}'"
+ if ! mount -t "${ro_dev_fs_type}" "/dev/mapper/${img_name}" "${mnt}" ; then
+ echo "ERROR: while mounting '/dev/mapper/${img_name}' to '${mnt}'"
+ launch_interactive_shell
+ fi
}
# args: /path/to/image_file, mountpoint
-_mnt_squashfs() {
- img="${1}"
- mnt="${2}"
- img_fullname="${img##*/}";
- img_name="${img_fullname%.*}"
- tmp_mnt="/ro_branch/${img_name}"
-
- if [ "${copytoram}" = "y" ]; then
+_mnt_sfs() {
+ local img="${1}"
+ local mnt="${2}"
+ local img_fullname="${img##*/}";
+
+ mkdir -p "${mnt}"
+
+ if [[ "${copytoram}" == "y" ]]; then
msg -n ":: Copying squashfs image to RAM..."
- /bin/cp "${img}" "/copytoram/${img_fullname}"
- if [ $? -ne 0 ]; then
- echo "ERROR: while copy ${img} to /copytoram/${img_fullname}"
+ if ! cp "${img}" "/copytoram/${img_fullname}" ; then
+ echo "ERROR: while copy '${img}' to '/copytoram/${img_fullname}'"
launch_interactive_shell
fi
img="/copytoram/${img_fullname}"
msg "done."
fi
-
- mkdir -p "${tmp_mnt}"
- /bin/mount -r -t squashfs "${img}" "${tmp_mnt}"
- if [ $? -ne 0 ]; then
- echo "ERROR: while mounting ${img} to ${tmp_mnt}"
+ _next_loop_dev
+ msg ":: Mounting '${img}' (SquashFS) to '${mnt}'"
+ if ! mount -r -t squashfs $(_make_loop_dev "${img}") "${mnt}" &> /dev/null ; then
+ echo "ERROR: while mounting '${img}' to '${mnt}'"
launch_interactive_shell
fi
-
- if [ "/${mnt#/*/}" = "/" ]; then
- _mnt_aufs "${tmp_mnt}" "${mnt}"
- else
- _mnt_bind "${tmp_mnt}" "${mnt}"
- fi
}
run_hook() {
- if [ "x${arch}" = "x" ]; then
- arch="$(uname -m)"
- fi
-
- if [ "x${rw_branch_size}" = "x" ]; then
- rw_branch_size="75%"
- fi
-
- if [ "x${copytoram_size}" = "x" ]; then
- copytoram_size="75%"
- fi
-
- if [ "x${archisobasedir}" = "x" ]; then
- archisobasedir="arch"
- fi
-
- if [ "x${isomounts}" != "x" ]; then
- isomounts="/bootmnt/${isomounts}"
+ [[ -z "${arch}" ]] && arch="$(uname -m)"
+ [[ -z "${cowspace_size}" ]] && cowspace_size="75%"
+ [[ -z "${copytoram_size}" ]] && copytoram_size="75%"
+ [[ -z "${archisobasedir}" ]] && archisobasedir="arch"
+ [[ -z "${archisodevice}" ]] && archisodevice="/dev/disk/by-label/${archisolabel}"
+ if [[ -z "${aitab}" ]]; then
+ aitab="/bootmnt/${archisobasedir}/aitab"
else
- isomounts="/bootmnt/${archisobasedir}/isomounts"
+ aitab="/bootmnt/${aitab}"
fi
-
- if [ "x${archisodevice}" = "x" ]; then
- archisodevice="/dev/disk/by-label/${archisolabel}"
- fi
-
# set mount handler for archiso
mount_handler="archiso_mount_handler"
}
+# This function is called normally from init script, but it can be called
+# as chain from other mount handlers.
+# args: /path/to/newroot
archiso_mount_handler() {
- newroot="${1}"
+ local newroot="${1}"
+ local fstype fserror
+
+ _init_loop_dev
msg ":: Waiting for boot device..."
- while ! poll_device ${archisodevice} 30; do
+ while ! poll_device "${archisodevice}" 30; do
echo "ERROR: boot device didn't show up after 30 seconds..."
echo " Falling back to interactive prompt"
echo " You can try to fix the problem manually, log out when you are finished"
launch_interactive_shell
done
- FSTYPE=$(blkid -o value -s TYPE -p ${archisodevice} 2> /dev/null)
- if [ -n "${FSTYPE}" ]; then
- if mount -r -t "${FSTYPE}" ${archisodevice} /bootmnt > /dev/null 2>&1; then
- if [ -e "${isomounts}" ]; then
- echo "SUCCESS: Mounted archiso volume successfully."
- fserror="0"
+ fstype=$(blkid -o value -s TYPE -p "${archisodevice}" 2> /dev/null)
+ if [[ -n "${fstype}" ]]; then
+ if mount -r -t "${fstype}" "${archisodevice}" /bootmnt; then
+ if [[ -f "${aitab}" ]]; then
+ msg ":: Mounted archiso volume successfully."
+ fserror=0
else
- echo "ERROR: Mounting was successful, but the ${isomounts} file does not exist."
- fserror="1"
+ echo "ERROR: Mounting was successful, but the '${aitab}' file does not exist."
+ fserror=1
fi
else
- echo "ERROR; Failed to mount ${archisodevice} (FS is ${FSTYPE})"
- fserror="1"
+ echo "ERROR; Failed to mount '${archisodevice}' (FS is ${fstype})"
+ fserror=1
fi
else
- echo "ERROR: ${archisodevice} found, but the filesystem type is unknown."
- fserror="1"
+ echo "ERROR: '${archisodevice}' found, but the filesystem type is unknown."
+ fserror=1
fi
- if [ "${fserror}" = "1" ]; then
+ if [[ ${fserror} -eq 1 ]]; then
echo " Falling back to interactive prompt"
echo " You can try to fix the problem manually, log out when you are finished"
launch_interactive_shell
fi
- if [ "${copytoram}" = "y" ]; then
+ if [[ "${copytoram}" == "y" ]]; then
msg -n ":: Mounting /copytoram (tmpfs) filesystem, size=${copytoram_size}..."
mount -t tmpfs -o "size=${copytoram_size}",mode=0755 copytoram /copytoram
msg "done."
fi
- msg -n ":: Mounting rw_branch (tmpfs) filesystem, size=${rw_branch_size}..."
- mount -t tmpfs -o "size=${rw_branch_size}",mode=0755 rw_branch /rw_branch
+ msg -n ":: Mounting /cowspace (tmpfs) filesystem, size=${cowspace_size}..."
+ mount -t tmpfs -o "size=${cowspace_size}",mode=0755 cowspace /cowspace
msg "done."
- msg ":: Mounting root (aufs) filesystem"
- /bin/mount -t aufs -o dirs=/rw_branch=rw union "${newroot}"
- if [ $? -ne 0 ]; then
- echo "ERROR: while mounting root (aufs) filesystem."
- launch_interactive_shell
- fi
-
- msg ":: Mounting images"
- while read img imgarch mountpoint type; do
- # check if this line is a comment (starts with #)
- [ "${img#"#"}" != "${img}" ] && continue
-
- [ "$imgarch" != "$arch" ] && continue
-
- [ ! -r "/bootmnt/${archisobasedir}/${img}" ] && continue
-
- if [ "${type}" = "bind" ]; then
- _mnt_bind "/bootmnt/${archisobasedir}/${img}" "${newroot}${mountpoint}"
- elif [ "${type}" = "squashfs" ]; then
- _mnt_squashfs "/bootmnt/${archisobasedir}/${img}" "${newroot}${mountpoint}"
+ local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
+ while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
+ [[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
+ [[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
+ if [[ "${aitab_fs_type}" != "none" ]]; then
+ if [[ "${aitab_sfs_comp}" != "none" ]]; then
+ _mnt_sfs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "/sfs/${aitab_img}"
+ _mnt_fs "/sfs/${aitab_img}/${aitab_img}.fs" "${newroot}${aitab_mnt}"
+ else
+ _mnt_fs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.fs" "${newroot}${aitab_mnt}"
+ fi
+ else
+ _mnt_sfs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "${newroot}${aitab_mnt}"
fi
- done < "${isomounts}"
+ done < "${aitab}"
- if [ "${copytoram}" = "y" ]; then
- /bin/umount /bootmnt
+ if [[ "${copytoram}" == "y" ]]; then
+ umount /bootmnt
else
- _mnt_bind /bootmnt "${newroot}/bootmnt"
+ mkdir "${newroot}/bootmnt"
+ mount --bind /bootmnt "${newroot}/bootmnt"
fi
}
diff --git a/archiso/install/archiso b/archiso/install/archiso
index 7ad9d06..3ac6246 100644
--- a/archiso/install/archiso
+++ b/archiso/install/archiso
@@ -1,25 +1,28 @@
install ()
{
- MODULES="cdrom ide-cd_mod ide-core ide-generic aufs squashfs isofs loop $(all_modules '/kernel/fs' | grep -v "nls") "
- MODULES="${MODULES} $(checked_modules "/usb/host" | grep -ve "_cs" -e "sl811-hcd" -e "isp116x-hcd")"
- MODULES=$(echo ${MODULES}) #trim whitespace
- if [ "x${MODULES}" != "x" ]; then
- MODULES="${MODULES} usb_storage sd_mod sr_mod"
- fi
+ MODULES="cdrom ide-cd_mod ide-core ide-generic loop dm-mod dm-snapshot squashfs isofs $(all_modules '/kernel/fs' | grep -v "nls")"
+ MODULES="${MODULES} $(checked_modules "/usb/host" | grep -ve "_cs" -e "sl811_hcd" -e "isp116x_hcd")"
+ MODULES="${MODULES} usb_storage sd_mod sr_mod"
MODULES="${MODULES} virtio_pci virtio_blk"
+ MODULES=$(echo ${MODULES}) #trim whitespace
BINARIES=""
FILES=""
- add_dir /rw_branch
- add_dir /ro_branch
+
+ add_dir /cowspace
add_dir /copytoram
add_dir /bootmnt
- add_device /lib/udev/devices/loop0 b 7 0
-
add_binary /lib/udev/cdrom_id
+ add_binary /sbin/blockdev
+ add_binary /sbin/lvm
+ add_binary /sbin/dmsetup
add_file /lib/udev/rules.d/60-cdrom_id.rules
+ add_file /lib/udev/rules.d/10-dm.rules
+ add_file /lib/udev/rules.d/13-dm-disk.rules
+ add_file /lib/udev/rules.d/95-dm-notify.rules
+ add_file /lib/udev/rules.d/11-dm-lvm.rules
SCRIPT="archiso"
}
diff --git a/archiso/install/archiso_pxe_nbd b/archiso/install/archiso_pxe_nbd
index fbf43c6..189a7b1 100644
--- a/archiso/install/archiso_pxe_nbd
+++ b/archiso/install/archiso_pxe_nbd
@@ -2,8 +2,12 @@
install ()
{
- MODULES="nbd $(checked_modules "/drivers/net/" | grep -v -e "/irda/" -e "/phy/" -e "/plip" -e "/ppp" -e "/wimax/" -e "/wireless/") "
-
+ MODULES="nbd"
+ MODULES="${MODULES} $(comm -2 -3 <(checked_modules "/drivers/net/" | sort) \
+ <(find $MODULEDIR/kernel/drivers/net/{irda,phy,wimax,wireless} \
+ -name '*.ko*' \
+ -exec bash -c 'printf "%s\n" "${@%%.ko*}" | sed "s@.*/@@;s@-@_@" | sort' _ {} +) \
+ | grep -v -e 'ppp_' -e 'plip' -e 'pppoe')"
BINARIES=""
FILES=""
SCRIPT="archiso_pxe_nbd"
diff --git a/archiso/mkarchiso b/archiso/mkarchiso
index a165d03..92b2a26 100755
--- a/archiso/mkarchiso
+++ b/archiso/mkarchiso
@@ -1,254 +1,439 @@
#!/bin/bash
-PKGLIST=""
-QUIET="y"
-FORCE="n"
-PACCONFIG="/etc/pacman.conf"
-export LABEL="ARCH_$(date +%Y%m)"
-PUBLISHER="Arch Linux <http://www.archlinux.org>"
-APPLICATION="Arch Linux Live/Rescue CD"
-COMPRESSION="xz"
-CREATE_DEFAULT="n"
-INSTALL_DIR="arch"
-
-APPNAME=$(basename "${0}")
-ARCH=$(uname -m)
-
-# usage: usage <exitvalue>
-usage ()
+set -e -u
+
+app_name=${0##*/}
+arch=$(uname -m)
+pkg_list=""
+quiet="y"
+pacman_conf="/etc/pacman.conf"
+export iso_label="ARCH_$(date +%Y%m)"
+iso_publisher="Arch Linux <http://www.archlinux.org>"
+iso_application="Arch Linux Live/Rescue CD"
+install_dir="arch"
+
+# Show an INFO message
+# $1: message string
+_msg_info() {
+ local _msg="${1}"
+ echo "[mkarchiso] INFO: ${_msg}"
+}
+
+# Show an ERROR message then exit with status
+# $1: message string
+# $2: exit code number (with 0 does not exit)
+_msg_error() {
+ local _msg="${1}"
+ local _error=${2}
+ echo
+ echo "[mkarchiso] ERROR: ${_msg}"
+ echo
+ if [[ ${_error} -gt 0 ]]; then
+ exit ${_error}
+ fi
+}
+
+# Show space usage similar to df, but better formatted.
+# $1: mount-point or mounted device.
+_show_space_usage () {
+ local _where="${1}"
+ local _fs _total _used _avail _pct_u=0 _mnt
+ read _fs _total _used _avail _pct_u _mnt < <(df -m "${_where}" | tail -1) &> /dev/null
+ _msg_info "Total: ${_total} MiB (100%) | Used: ${_used} MiB (${_pct_u}) | Avail: ${_avail} MiB ($((100 - ${_pct_u%\%}))%)"
+}
+
+# Mount a filesystem (trap signals in case of error for unmounting it
+# $1: source image
+# $2: mount-point
+_mount_fs() {
+ local _src="${1}"
+ local _dst="${2}"
+ trap "_umount_fs ${_src}" EXIT HUP INT TERM
+ mkdir -p "${_dst}"
+ _msg_info "Mounting '${_src}' on '${_dst}'"
+ mount "${_src}" "${_dst}"
+ _show_space_usage "${_dst}"
+}
+
+# Unmount a filesystem (and untrap signals)
+# $1: mount-point or device/image
+_umount_fs() {
+ local _dst="${1}"
+ _show_space_usage "${_dst}"
+ _msg_info "Unmounting '${_dst}'"
+ umount "${_dst}"
+ rmdir "${_dst}"
+ trap - EXIT HUP INT TERM
+}
+
+# Compare if a file/directory (source) is newer than other file (target)
+# $1: source file/directory
+# $2: target file
+# return: 0 if target does not exists or if target is older than source.
+# 1 if target is newer than source
+_is_directory_changed() {
+ local _src="${1}"
+ local _dst="${2}"
+
+ if [ -e "${_dst}" ]; then
+ if [[ $(find ${_src} -newer ${_dst} | wc -l) -gt 0 ]]; then
+ _msg_info "Target '${_dst}' is older than '${_src}', updating."
+ rm -f "${_dst}"
+ return 0
+ else
+ _msg_info "Target '${_dst}' is up to date with '${_src}', skipping."
+ return 1
+ fi
+ else
+ _msg_info "Target '${_dst}' does not exist, making it from '${_src}'"
+ return 0
+ fi
+}
+
+# Show help usage, with an exit status.
+# $1: exit status number.
+_usage ()
{
- echo "usage ${APPNAME} [options] command <command options>"
+ echo "usage ${app_name} [options] command <command options>"
echo " general options:"
- echo " -f Force overwrite of working files/squashfs image/bootable image"
- echo " -p PACKAGE(S) Additional package(s) to install, can be used multiple times"
- echo " -C <file> Config file for pacman. Default $PACCONFIG"
+ echo " -p PACKAGE(S) Package(s) to install, can be used multiple times"
+ echo " -C <file> Config file for pacman. Default ${pacman_conf}"
echo " -L <label> Set a label for the disk"
echo " -P <publisher> Set a publisher for the disk"
echo " -A <application> Set an application name for the disk"
- echo " -c <compressor> Set SquashFS compression type: gzip, xz or lzo. Default $COMPRESSION"
- echo " NOTES:"
- echo " xz: needs Linux >= 2.6.38"
- echo " lzo: needs Linux >= 2.6.36"
- echo " -D <install_dir> Set an install_dir. All files will by located here on ISO (except for syslinux)"
- echo " Default $INSTALL_DIR"
+ echo " -D <install_dir> Set an install_dir. All files will by located here."
+ echo " Default ${install_dir}"
echo " NOTE: Max 8 characters, use only [a-z0-9]"
- echo " -d Create default user directory /home/arch"
echo " -v Enable verbose output"
echo " -h This message"
echo " commands:"
echo " create <dir>"
echo " create a base directory layout to work with"
echo " includes all specified packages"
+ echo " prepare <dir>"
+ echo " build all images"
echo " iso <dir> <image name>"
echo " build an iso image from the working dir"
- exit $1
+ exit ${1}
}
-while getopts 'p:C:L:P:A:c:D:dfvh' arg; do
- case "${arg}" in
- p) PKGLIST="${PKGLIST} ${OPTARG}" ;;
- C) PACCONFIG="${OPTARG}" ;;
- L) LABEL="${OPTARG}" ;;
- P) PUBLISHER="${OPTARG}" ;;
- A) APPLICATION="${OPTARG}" ;;
- c) COMPRESSION="${OPTARG}" ;;
- D) INSTALL_DIR="${OPTARG}" ;;
- d) CREATE_DEFAULT="y" ;;
- f) FORCE="y" ;;
- v) QUIET="n" ;;
- h|?) usage 0 ;;
- *) echo "invalid argument '${arg}'"; usage 1 ;;
+# Shows configuration according to command mode.
+# $1: create | prepare | iso
+_show_config () {
+ local _mode="$1"
+ echo
+ _msg_info "Configuration settings"
+ _msg_info " Command: ${command_name}"
+ _msg_info " Architecture: ${arch}"
+ _msg_info " Working directory: ${work_dir}"
+ _msg_info " Installation directory: ${install_dir}"
+ case "${_mode}" in
+ create)
+ _msg_info " Pacman config file: ${pacman_conf}"
+ _msg_info " Packages: ${pkg_list}"
+ ;;
+ prepare)
+ ;;
+ iso)
+ _msg_info " Image name: ${img_name}"
+ _msg_info " Disk label: ${iso_label}"
+ _msg_info " Disk publisher: ${iso_publisher}"
+ _msg_info " Disk application: ${iso_application}"
+ ;;
esac
-done
-
-#trim spaces
-PKGLIST="$(echo $PKGLIST)"
-
-shift $(($OPTIND - 1))
-
-# do UID checking here so someone can at least get usage instructions
-if [ "$EUID" != "0" ]; then
- echo "error: This script must be run as root."
- exit 1
-fi
-
-if [ ! -f "$PACCONFIG" ]; then
- echo "error: pacman config file '$PACCONFIG' does not exist"
- exit 1
-fi
-
-command_name="${1}"
-work_dir=""
-imgname=""
-
-case "${command_name}" in
- create) work_dir="${2}"; imgname="none" ;;
- iso) work_dir="${2}"; imgname="${3}" ;;
- *) echo "invalid command name '${command_name}'"; usage 1 ;;
-esac
-
-[ "x${imgname}" = "x" ] && echo "Image name must be specified" && usage 1
-[ "x${work_dir}" = "x" ] && echo "Please specify a working directory" && usage 1
-
-echo "${APPNAME} : Configuration Settings"
-echo " working directory: ${work_dir}"
-echo " image name: ${imgname}"
+ echo
+}
-# usage: _pacman <packages>...
+# Install desired packages to root-image
_pacman ()
{
- local ret
- if [ "${QUIET}" = "y" ]; then
- mkarchroot -n -C "$PACCONFIG" -f "${work_dir}/root-image" $* 2>&1 >/dev/null
- ret=$?
+ _msg_info "Installing packages to '${work_dir}/root-image/'"
+
+ if [[ "${quiet}" = "y" ]]; then
+ mkarchroot -n -C "${pacman_conf}" -f "${work_dir}/root-image" $* &> /dev/null
else
- mkarchroot -n -C "$PACCONFIG" -f "${work_dir}/root-image" $*
- ret=$?
+ mkarchroot -n -C "${pacman_conf}" -f "${work_dir}/root-image" $*
fi
# Cleanup
- find "${work_dir}" -name *.pacnew -name *.pacsave -name *.pacorig -delete
-
- if [ $ret -ne 0 ]; then
- exit 1
- fi
+ find "${work_dir}" -name "*.pacnew" -name "*.pacsave" -name "*.pacorig" -delete
}
-command_create () {
- echo "====> Creating working directory: ${work_dir}"
- mkdir -p "${work_dir}/iso/${INSTALL_DIR}/${ARCH}"
- mkdir -p "${work_dir}/root-image/"
-
- if [ "${PKGLIST}" != "" ]; then
- echo "====> Installing packages to '${work_dir}/root-image/'"
- _pacman "${PKGLIST}"
-
- echo "Cleaning up what we can"
- if [ -d "${work_dir}/root-image/boot/" ]; then
- # remove the initcpio images that were generated for the host system
- find "${work_dir}/root-image/boot" -name '*.img' -delete
- fi
-
- if [ ${CREATE_DEFAULT} == "y" ]; then
- if [ -d "${work_dir}/root-image/home/" ]; then
- echo "Creating default home directory"
- install -d -o1000 -g100 -m0755 "${work_dir}/root-image/home/arch"
- fi
- fi
-
- # Delete pacman database sync cache files (*.tar.gz)
+# Cleanup root-image
+_cleanup () {
+ _msg_info "Cleaning up what we can on root-image"
+ # remove the initcpio images that were generated for the host system
+ if [[ -d "${work_dir}/root-image/boot" ]]; then
+ find "${work_dir}/root-image/boot" -name '*.img' -delete
+ fi
+ # Delete pacman database sync cache files (*.tar.gz)
+ if [[ -d "${work_dir}/root-image/var/lib/pacman" ]]; then
find "${work_dir}/root-image/var/lib/pacman" -maxdepth 1 -type f -delete
- # Delete pacman database sync cache
+ fi
+ # Delete pacman database sync cache
+ if [[ -d "${work_dir}/root-image/var/lib/pacman/sync" ]]; then
find "${work_dir}/root-image/var/lib/pacman/sync" -delete
- # Delete pacman package cache
+ fi
+ # Delete pacman package cache
+ if [[ -d "${work_dir}/root-image/var/cache/pacman/pkg" ]]; then
find "${work_dir}/root-image/var/cache/pacman/pkg" -type f -delete
- # Delete all log files, keeps empty dirs.
+ fi
+ # Delete all log files, keeps empty dirs.
+ if [[ -d "${work_dir}/root-image/var/log" ]]; then
find "${work_dir}/root-image/var/log" -type f -delete
- # Delete all temporary files and dirs
+ fi
+ # Delete all temporary files and dirs
+ if [[ -d "${work_dir}/root-image/var/tmp" ]]; then
find "${work_dir}/root-image/var/tmp" -mindepth 1 -delete
- # Delete all temporary files and dirs
+ fi
+ # Delete all temporary files and dirs
+ if [[ -d "${work_dir}/root-image/tmp" ]]; then
find "${work_dir}/root-image/tmp" -mindepth 1 -delete
fi
}
-# _mksquash dirname
-_mksquash () {
- if [ ! -d "$1" ]; then
- echo "Error: '$1' is not a directory"
- return 1
- fi
+# Makes a SquashFS filesystem image of file/directory passes as argument with desired compression.
+# $1: Source file/directory
+# $2: SquashFS compression type (gzip | lzo | xz)
+_mksfs () {
+ local _src="${1}"
+ local _sfs_comp="${2}"
- sqimg="${work_dir}/iso/${INSTALL_DIR}/${ARCH}/$(basename ${1}).sqfs"
- echo "====> Generating SquashFS image for '${1}'"
- if [ -e "${sqimg}" ]; then
- dirhaschanged=$(find ${1} -newer ${sqimg})
- if [ "${dirhaschanged}" != "" ]; then
- echo "SquashFS image '${sqimg}' is not up to date, rebuilding..."
- rm "${sqimg}"
- else
- echo "SquashFS image '${sqimg}' is up to date, skipping."
- return
- fi
+ if [[ ! -e "${work_dir}/${_src}" ]]; then
+ _msg_error "The path '${work_dir}/${_src}' does not exist" 1
fi
- echo "Creating SquashFS image. This may take some time..."
- start=$(date +%s)
- if [ "${QUIET}" = "y" ]; then
- mksquashfs "${1}" "${sqimg}" -noappend -comp "${COMPRESSION}" >/dev/null
+ local _sfs_img="${work_dir}/${_src}.sfs"
+
+ _msg_info "Creating SquashFS image for '${work_dir}/${_src}', This may take some time..."
+ local _seconds=${SECONDS}
+ if [[ "${quiet}" = "y" ]]; then
+ mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}" &> /dev/null
else
- mksquashfs "${1}" "${sqimg}" -noappend -comp "${COMPRESSION}"
+ mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}"
fi
- minutes=$(echo $start $(date +%s) | awk '{ printf "%0.2f",($2-$1)/60 }')
- echo "Image creation done in $minutes minutes."
+ _seconds=$((SECONDS - _seconds))
+ printf "[mkarchiso] INFO: Image creation done in %02d:%02d minutes\n" $((_seconds / 60)) $((_seconds % 60))
}
-_imgcommon () {
- for d in $(find "${work_dir}" -maxdepth 1 -type d -name '[^.]*'); do
- if [ "$d" != "${work_dir}/iso" -a \
- "$(basename "$d")" != "iso" -a \
- "$d" != "${work_dir}" ]; then
- _mksquash "$d"
- fi
- done
+# Makes a filesystem from a source directory.
+# $1: Source directory
+# $2: Target filesystem type (ext4 | ext3 | ext2 | xfs)
+# $3: Size of target filesystem. Can be an absolute value in MiB, or relative value of desired free space (1% - 99%)
+_mkfs () {
+ local _src="${1}"
+ local _fs_type="${2}"
+ local _fs_size="${3}"
- echo "====> Making bootable image"
+ local _fs_src="${work_dir}/${_src}"
+ local _fs_img="${work_dir}/${_src}.fs"
- # Sanity checks
- if [ ! -d "${work_dir}/iso" ]; then
- echo "Error: '${work_dir}/iso' doesn't exist. What did you do?!"
- exit 1
+ if [[ ! -e "${_fs_src}" ]]; then
+ _msg_error "The path '${_fs_src}' does not exist" 1
fi
- if [ ! -f "${work_dir}/iso/${INSTALL_DIR}/isomounts" ]; then
- echo "Error: the isomounts file doesn't exist. This image won't do anything"
- echo " Protecting you from yourself and erroring out here..."
- exit 1
- fi
+ local _spc_used
+ _spc_used=$(du -sxm "${_fs_src}" | awk '{print $1}')
- if [ -e "${imgname}" ]; then
- if [ "${FORCE}" = "y" ]; then
- echo "Removing existing bootable image..."
- rm -rf "${imgname}"
- else
- echo "Error: Image '${imgname}' already exists, aborting."
- exit 1
+ # Caculate FS size with desired % of free space, adds 10% overhead to used space.
+ if [[ ${_fs_size} != ${_fs_size%\%} ]]; then
+ if [[ ${_fs_size%\%} -le 0 || ${_fs_size%\%} -ge 100 ]]; then
+ _msg_error "Invalid percentage of free space specified '${_fs_size}' on '${_src}', should be 0% < x < 100%" 1
+ fi
+ _fs_size=$((_spc_used * 110 / (100 - ${_fs_size%\%})))
+ else
+ local _spc_used_over=$((_spc_used * 11 / 10))
+ if [[ ${_fs_size} -lt ${_spc_used_over} ]]; then
+ _msg_error "Filesystem size specified '${_fs_size}' MiB for '${_src}' is too small, must be at least '${_spc_used_over}' MiB" 1
fi
fi
- if ! sed "s|%ARCHISO_LABEL%|${LABEL}|g;
- s|%INSTALL_DIR%|${INSTALL_DIR}|g;
- s|%ARCH%|${ARCH}|g" -i ${work_dir}/iso/syslinux/syslinux.cfg; then
- echo "Error: ${work_dir}/iso/syslinux/syslinux.cfg, doesn't exist, aborting."
- exit 1
+ _msg_info "Creating ${_fs_type} image of ${_fs_size} MiB"
+ dd of="${_fs_img}" count=0 bs=1M seek=${_fs_size} &> /dev/null
+ local _qflag=""
+ if [[ ${quiet} == "y" ]]; then
+ _qflag="-q"
fi
+ case "${_fs_type}" in
+ ext4)
+ mkfs.ext4 ${_qflag} -O ^has_journal -m 0 -F "${_fs_img}"
+ tune2fs -c 0 -i 0 "${_fs_img}" &> /dev/null
+ ;;
+ ext3)
+ mkfs.ext3 ${_qflag} -m 0 -F "${_fs_img}"
+ tune2fs -c 0 -i 0 "${_fs_img}" &> /dev/null
+ ;;
+ ext2)
+ mkfs.ext2 ${_qflag} -m 0 -F "${_fs_img}"
+ tune2fs -c 0 -i 0 "${_fs_img}" &> /dev/null
+ ;;
+ xfs)
+ mkfs.xfs ${_qflag} "${_fs_img}"
+ ;;
+ *)
+ _msg_error "Invalid filesystem: ${_fs_type}" 1
+ ;;
+ esac
+ _mount_fs "${_fs_img}" "${work_dir}/mnt/${_src}"
+ _msg_info "Copying '${_fs_src}/' to '${work_dir}/mnt/${_src}/'"
+ rsync -aH "${_fs_src}/" "${work_dir}/mnt/${_src}/"
+ _umount_fs "${work_dir}/mnt/${_src}"
}
+# Create an ISO9660 filesystem from "iso" directory.
command_iso () {
- _imgcommon
+ if [[ ! -f "${work_dir}/iso/isolinux/isolinux.bin" ]]; then
+ _msg_error "The file '${work_dir}/iso/isolinux/isolinux.bin' does not exist." 1
+ fi
+
+ _show_config iso
+
+ _is_directory_changed "${work_dir}/iso" "${img_name}"
- echo "Creating ISO image..."
- qflag=""
- [ "${QUIET}" = "y" ] && qflag="-quiet"
- mkisofs ${qflag} -r -l \
- -b syslinux/isolinux.bin -c syslinux/boot.cat \
+ _msg_info "Creating ISO image..."
+ local _qflag=""
+ if [[ ${quiet} == "y" ]]; then
+ _qflag="-quiet"
+ fi
+ mkisofs ${_qflag} -r -l \
+ -b isolinux/isolinux.bin -c isolinux/boot.cat \
-uid 0 -gid 0 \
-udf -allow-limited-size -iso-level 3 \
-input-charset utf-8 -p "prepared by mkarchiso" \
-no-emul-boot -boot-load-size 4 -boot-info-table \
- -publisher "${PUBLISHER}" \
- -A "${APPLICATION}" \
- -V "${LABEL}" \
- -o "${imgname}" "${work_dir}/iso/"
- isohybrid "${imgname}"
+ -publisher "${iso_publisher}" \
+ -A "${iso_application}" \
+ -V "${iso_label}" \
+ -o "${img_name}" "${work_dir}/iso/"
+ isohybrid "${img_name}"
+ _msg_info "Done! | $(ls -sh ${img_name})"
+}
+
+# Parse aitab and create each filesystem specified on that, and push it in "iso" directory.
+command_prepare () {
+ if [[ ! -f "${work_dir}/iso/${install_dir}/aitab" ]]; then
+ _msg_error "The file '${work_dir}/iso/${install_dir}/aitab' does not exist." 1
+ fi
+ _show_config prepare
+
+ _cleanup
+ local _aitab_img _aitab_mnt _aitab_arch _aitab_sfs_comp _aitab_fs_type _aitab_fs_size
+ while read _aitab_img _aitab_mnt _aitab_arch _aitab_sfs_comp _aitab_fs_type _aitab_fs_size ; do
+ if [[ ${_aitab_img} =~ ^# ]]; then
+ continue
+ fi
+ if [[ ${_aitab_sfs_comp} == "none" && ${_aitab_fs_type} == "none" ]]; then
+ _msg_error "In aitab, both fields 'sfs_comp' and 'fs_type' are set to none for '${_aitab_img}' image" 1
+ fi
+ local _src="${work_dir}/${_aitab_img}"
+ local _dst="${work_dir}/iso/${install_dir}/${_aitab_arch}"
+ mkdir -p "${_dst}"
+ if [[ ${_aitab_fs_type} != "none" ]]; then
+ if [[ ${_aitab_sfs_comp} != "none" ]]; then
+ if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.fs.sfs"; then
+ _mkfs ${_aitab_img} ${_aitab_fs_type} ${_aitab_fs_size}
+ _mksfs ${_aitab_img}.fs ${_aitab_sfs_comp}
+ mv "${_src}.fs.sfs" "${_dst}"
+ rm "${_src}.fs"
+ fi
+ else
+ if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.fs"; then
+ _mkfs ${_aitab_img} ${_aitab_fs_type} ${_aitab_fs_size}
+ mv "${work_dir}/${_aitab_img}.fs" "${_dst}"
+ fi
+ fi
+ else
+ if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.sfs"; then
+ _mksfs ${_aitab_img} ${_aitab_sfs_comp}
+ mv "${work_dir}/${_aitab_img}.sfs" "${_dst}"
+ fi
+ fi
+ done < "${work_dir}/iso/${install_dir}/aitab"
+}
+
+# Install packages on root-image.
+# A basic check to avoid double execution/reinstallation is done via hashing package names.
+command_create () {
+ if [[ ! -f "${pacman_conf}" ]]; then
+ _msg_error "Pacman config file '${pacman_conf}' does not exist" 1
+ fi
+
+ #trim spaces
+ pkg_list="$(echo ${pkg_list})"
+
+ if [[ -z ${pkg_list} ]]; then
+ _msg_error "Packages must be specified" 0
+ _usage 1
+ fi
+
+ _show_config create
+
+ local _pkg_list_hash
+ _pkg_list_hash=$(echo ${pkg_list} | sort -u | md5sum | cut -c1-32)
+ if [[ -f "${work_dir}/create.${_pkg_list_hash}" ]]; then
+ _msg_info "These packages are already installed, skipping."
+ else
+ mkdir -p "${work_dir}/root-image/"
+ : > "${work_dir}/create.${_pkg_list_hash}"
+ _pacman "${pkg_list}"
+ fi
}
-# Go through the main commands in order. If 'all' was specified, then we want
-# to do everything. Start with 'install'.
-if [ "${command_name}" = "create" ]; then
- command_create
+
+if [[ ${EUID} -ne 0 ]]; then
+ _msg_error "This script must be run as root." 1
+fi
+
+while getopts 'p:C:L:P:A:D:fvh' arg; do
+ case "${arg}" in
+ p) pkg_list="${pkg_list} ${OPTARG}" ;;
+ C) pacman_conf="${OPTARG}" ;;
+ L) iso_label="${OPTARG}" ;;
+ P) iso_publisher="${OPTARG}" ;;
+ A) iso_application="${OPTARG}" ;;
+ D) install_dir="${OPTARG}" ;;
+ v) quiet="n" ;;
+ h|?) _usage 0 ;;
+ *)
+ _msg_error "Invalid argument '${arg}'" 0
+ _usage 1
+ ;;
+ esac
+done
+
+shift $((OPTIND - 1))
+
+if [[ $# -lt 1 ]]; then
+ _msg_error "No command specified" 0
+ _usage 1
fi
-if [ "${command_name}" = "iso" ]; then
- command_iso
+command_name="${1}"
+
+if [[ $# -lt 2 ]]; then
+ _msg_error "No working directory specified" 0
+ _usage 1
fi
+work_dir="${2}"
+
+case "${command_name}" in
+ create)
+ command_create
+ ;;
+ prepare)
+ command_prepare
+ ;;
+ iso)
+ if [[ $# -lt 3 ]]; then
+ _msg_error "No image specified" 0
+ _usage 1
+ fi
+ img_name="${3}"
+ command_iso
+ ;;
+ *)
+ _msg_error "Invalid command name '${command_name}'" 0
+ _usage 1
+ ;;
+esac
# vim:ts=4:sw=4:et: